#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "jpeglib.h"

int dodecompress(unsigned char *jpegdata, int jpegsize)
{
    struct jpeg_decompress_struct cinfo;
    JSAMPARRAY buffer;		/* Output row buffer */
    int row_stride;		/* physical row width in output buffer */
    struct jpeg_error_mgr jerr;

    cinfo.err = jpeg_std_error(&jerr);
    jpeg_create_decompress(&cinfo);
    jpeg_mem_src(&cinfo, jpegdata, jpegsize);
    (void) jpeg_read_header(&cinfo, TRUE);
    (void) jpeg_start_decompress(&cinfo);
    row_stride = cinfo.output_width * cinfo.output_components;
    buffer = (*cinfo.mem->alloc_sarray)
	((j_common_ptr) &cinfo, JPOOL_IMAGE, row_stride, 1);

    if (buffer == NULL)
	return;

/*     imgw = cinfo.output_width;
    imgh = cinfo.output_height;
    ystart = si->height/2 - imgh/2;
    xstart = si->width/2 - imgw/2;
    bpp = cinfo.output_components;
    y = 0; */
    while (cinfo.output_scanline < cinfo.output_height) {
	/* jpeg_read_scanlines expects an array of pointers to scanlines.
	 * Here the array is only one element long, but you could ask for
	 * more than one scanline at a time if that's more convenient.
	 */
/* 	unsigned char *imgbuf;
	unsigned char *line_buf =
	    si->base_buf + (si->scanline * y) + (si->scanline * ystart);  */

	jpeg_read_scanlines(&cinfo, buffer, 1);
/* 	imgbuf = buffer[0];
	imgcnt = 0;

	for (x = xstart; x < si->width; x++)
	{
	    unsigned char *buf = line_buf + (si->bpp * x);

 	    if (x < xstart + imgw) {
		*buf = imgbuf[imgcnt+2];
		*(buf + 1) = imgbuf[imgcnt + 1];
		*(buf + 2) = imgbuf[imgcnt];
		*(buf + 3) = 0;
		imgcnt += 3;
	    }

	}
 	if (y >= imgh + ystart)
	    break;
	y++;  */
    }

    {
	int i = 0;
	int end = jpegsize - 48;
	while (i < 48) {
	    printf("%x ", (int)jpegdata[end + i] & 0xff);
	    i++;
	}
    }

    (void) jpeg_finish_decompress(&cinfo);
    jpeg_destroy_decompress(&cinfo);


}

struct JpegInfo {
    unsigned char *addr;
    int size;
};

int main(int argc, char *argv[])
{
    int i = 0;
    int fl;
    int imgcnt;
    int *offsets;
    int offset;
    struct JpegInfo *jinfos;

    fl = open(argv[1], O_RDONLY);
    if (fl < 0) {
	perror("game over");
	exit(1);
    }
    read(fl, &imgcnt, sizeof(int));
    printf("There are %d offsets in the archive\n", imgcnt);
    offsets = malloc(imgcnt * sizeof(int));
    while (i <= imgcnt) {
	offset = 0;
	read(fl, &offset, sizeof(int));
	printf("offset %d : %d\n", i, offset);
	offsets[i] = offset;
	i ++;
    }
    i = 0;
    while (i < imgcnt) {
	int jpegsize = 0;
	unsigned char *jpegdata;

	lseek(fl, offsets[i], SEEK_SET);
	jpegsize = offsets[i+1] - offsets[i];
	jpegdata = malloc(jpegsize);
	if (read(fl, jpegdata, jpegsize) < 0) {
	    perror("read error\n");
	    exit(1);
	}
	dodecompress(jpegdata, jpegsize);
	printf("offset %d : %d jpegsize: %d\n", i, offsets[i], jpegsize);
	i ++;
    }
}
